//2-button quadratic equation solver						JaS
//https://en.m.wikipedia.org/wiki/Quadratic_equation


#include <Wire.h> 
#include <LiquidCrystal_I2C.h> 
LiquidCrystal_I2C lcd(0x27, 16, 2);


const int buttonPinA = 4;          		// Pin  button A
const int buttonPinB = 7;          		// Pin button B
int buttonstateA = LOW;          		// current signal button A
int buttonstateB = LOW;          		// current signal button B


int buttonpressedA = 0;          		// query button A
int buttonpressedB = 0;         		// query button B

int debouncetime = 300;            		// time for debounce, adjust!
 
unsigned long buttontime = 0;      		// time for press buttons
int buttonvalueA = 0;     				// variable, count up
int buttonvalueB = 0;     				// variable, count up

//------------Variables for calculation----------------

float Pvalue = 0;           			// variable for P-value
float Qvalue = 0;           			// variable for Q-value
float PvalueV = 0;           			// variable for P-value, corrected sign (positive / negative)
float QvalueV = 0;           			// variable for Q-value, corrected sign (positive / negative)

float Y0 = 0;                          	// support variable 0
float Y1 = 0;                          	// support variable 1
float Y2 = 0;                          	// support variable 2
float Y3 = 0;                          	// support variable 2
float Y4 = 0;                          	// support variable 2

float X1 = 0;		                	// result 1
float X2 = 0;							// result 2

byte VZP = 0;							// sign corrected variable P-value
byte VZQ = 0;							// sign corrected variable Q-value
byte VZD = 2;							// variable devisor


byte reset1 = 0;          				// variable to reset buttonvalueB   
byte reset2 = 0;          				// variable to reset buttonvalueB
byte reset3 = 0;          				// variable to reset buttonvalueB
byte reset4 = 0;          				// variable to reset buttonvalueB
byte reset5 = 0;          				// variable to reset buttonvalueB
byte reset6 = 0;          				// variable to reset buttonvalueB

int val;

void setup() {
  pinMode(buttonPinA, INPUT);   	 	// input button pin
  pinMode(buttonPinB, INPUT);    		// input button pin
  lcd.init(); 							// start LCD 
  lcd.backlight(); 						// bachklight switch  (lcd.noBacklight(); switch off).
  
   
  Serial.begin(9600);


}

void loop() 

  {
    buttonstateA = digitalRead(buttonPinA);
    buttonstateB = digitalRead(buttonPinB);
    
    
    if (buttonstateA == HIGH)
    {
      buttontime = millis();
      buttonpressedA = 1; 
    }
   else if (buttonstateB == HIGH)
    {
      buttontime = millis();
      buttonpressedB = 1;
    } 
    if ((millis() - buttontime > debouncetime) && buttonpressedA == 1)
    {
     buttonvalueA++;              		                    // buttonvalue count up
      buttonpressedA = 0;      		                        // reset pressed button    
    }
   else if  ((millis() - buttontime > debouncetime) && buttonpressedB == 1)
    {
     buttonvalueB++;              		                    // buttonvalue count up
      buttonpressedB = 0;      		                        // reset pressed button
    }


 //---------------------------------- level 0 ------------------------------------------------------------- 
  
  
  if (buttonvalueA == 0)                              	   // button not pressed, yet, level 0 
   {
    (buttonvalueA = 0);
    (buttonvalueB = 0);
    
    lcd.setCursor(0, 0); 
    lcd.print("   PQ-Formula   "); 
	lcd.setCursor(0, 1); 
    lcd.print("     Solver     ");
   }


 //---------------------------------- level 1 -------------------------------------------------------------
 
    
  else if (buttonvalueA ==1)      // 1. level P-value
   {
    if (reset1 != 1)              //  reset buttonvalueB --> go through IF loop once
    {
      (buttonvalueB = 0);
      (reset1 = 1);
      lcd.setCursor(1, 1); 
     lcd.print("            ");   // delete text
    }
     Pvalue = buttonvalueB;
 
     lcd.setCursor(0, 0); 
     lcd.print("P-value          "); 
     lcd.setCursor(1, 1); 
     lcd.print(Pvalue); 
   }


 //---------------------------------- level 2 -------------------------------------------------------------
 
    
  else if (buttonvalueA ==2)      // 2. level change sign P-value
   {
    if (reset2 != 1)              //  reset buttonvalueB --> go through IF loop once
    {
      (buttonvalueB = 0);
      (reset2 = 1);
    }
     
		VZP = buttonvalueB % VZD; // Modulo calculation: Rest = value/2
    
 
	if (VZP == 1)				  // If rest = 1, Pvalue is negative
	{
		(PvalueV = -Pvalue );
	}
  	else 
	{
  		(PvalueV = Pvalue);
  	}

     lcd.setCursor(0, 0); 
     lcd.print("Sign P-value    ");
	 if (PvalueV >= 0)			 // adjust display, overwrite old character. If value is positive, Wenn value positiv, set one blank to overwrite the minus from the negative value.
	{
  lcd.setCursor(0, 1);
  lcd.print(" ");
  lcd.setCursor(1, 1);
  lcd.print(PvalueV);
	}
	 else
	{
  lcd.setCursor(0, 1);
	 lcd.print(PvalueV);
	 }
//  lcd.print(VZP); 


   }


 //---------------------------------- level 3 -------------------------------------------------------------



  else if (buttonvalueA ==3)      // 3. level Q-value
  
     
   {
    
      if (reset3 != 1)            //  reset buttonvalueB --> go through IF loop once
    {
      (buttonvalueB = 0);
      (reset3 = 1);
    }

    
   
     Qvalue = buttonvalueB;
     
     lcd.setCursor(0, 1);
     lcd.print(" ");
     lcd.setCursor(0, 0); 
     lcd.print("Q-value          ");
     lcd.setCursor(1, 1); 
     lcd.print(Qvalue); 
   }


 //---------------------------------- level 4 -------------------------------------------------------------


  else if (buttonvalueA ==4)      // 4. level change sign Q-value
   {
    if (reset4 != 1)              //  reset buttonvalueB --> go through IF loop once
    {
      (buttonvalueB = 0);
      (reset4 = 1);
    }
		
		VZQ = buttonvalueB % VZD; // Modulo calculation: Rest = value/2
    
 
	if (VZQ == 1)				  // If Rest = 1 , Qvalue is negative
	{
		(QvalueV = -Qvalue );
	}
  	else 
	{
  		(QvalueV = Qvalue);
  	}


      lcd.setCursor(0, 0);
      lcd.print("Sign Q-value    ");

	 if (QvalueV >= 0)			   // adjust display, overwrite old character. If value is positive, Wenn value positiv, set one blank to overwrite the minus from the negative value.
	{
  lcd.setCursor(0, 1);
  lcd.print(" ");
  lcd.setCursor(1, 1);
  lcd.print(QvalueV);
	}
	 else
	{
  lcd.setCursor(0, 1);
	 lcd.print(QvalueV);
	 }

   }


 //---------------------------------- level 5 -------------------------------------------------------------


  else if (buttonvalueA ==5)      // 5. level caldulate X1 and X2
   {
    if (reset5 != 1)              //  reset buttonvalueB --> go through IF loop once
    {
      (buttonvalueB = 0);
      (reset5 = 1);
     lcd.setCursor(0, 0);
     lcd.print("X1=             ");
     lcd.setCursor(0, 1);
     lcd.print("X2=             ");
    }


//		X1 = -PvalueV/2 + sqrt (sq(PvalueV/2)-QvalueV);

//		X2 = -PvalueV/2 - sqrt (sq(PvalueV/2)-QvalueV);

   
      Y0 = sq (PvalueV/2);
      Y1 = Y0 - QvalueV; 		  //    < 0, no result, = 0 one result, > 0 two results!
      Y2 = sqrt (Y1);
      X1 = -PvalueV/2 - Y2;
      X2 = -PvalueV/2 + Y2;


       
     lcd.setCursor(4, 0);
     lcd.print(X1);     		  // Output X1
	 
     lcd.setCursor(4, 1);
	   lcd.print(X2);		  	  // Output X2
   }


 //---------------------------------- level 6 -------------------------------------------------------------


  else if (buttonvalueA ==6)      // 6. level terminate calculation --> switch to first level
   {
    (buttonvalueA = 0);
    (buttonvalueB = 0);
     (Pvalue = 0);
     (PvalueV = 0);
     (Qvalue = 0);
     (QvalueV = 0);
     (VZP = 0);
     (VZQ = 0);
     (X1 = 0);
     (X2 = 0);
     (reset1 = 0);
     (reset2 = 0);
     (reset3 = 0);
     (reset4 = 0);
     (reset5 = 0);
     (reset6 = 0);

     
  	 lcd.setCursor(0, 0); 
     lcd.print("    The End     ");
     lcd.setCursor(0, 1);
     lcd.print("                ");
     delay(2000);

   }
  
// -------------------------------- output Serial Monitor ------------------------
  
  //Serial.print(buttonvalueA);
//delay(6); 
  Serial.print(buttonvalueB); 
//delay(6);
  Serial.println(Qvalue);  
//delay(6);
//  Serial.println(buttontime);  
  
 }

  
